import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.AbstractAction;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import com.steema.teechart.Commander;
import com.steema.teechart.TChart;

/**
 *
 */

/**
 * @author fattazzo
 *
 */
public class Main extends JFrame {

	private class ChangeMapAction extends AbstractAction {

		private static final long serialVersionUID = -4352186105089178434L;

		@Override
		public void actionPerformed(ActionEvent evt) {
			JRadioButton radioButton = (JRadioButton) evt.getSource();

			try {
				series.clear();
				series.loadMapFromResource(series, radioButton.getText());
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	public static void main(String[] args) {
		Main main = new Main();
		main.setVisible(true);
	}

	private TChart chart;

	private MyWorld series;

	private static final long serialVersionUID = 4648172894076113183L;

	/**
	 * Costruttore.
	 *
	 * @throws Exception
	 */
	public Main() throws RuntimeException {
		super();
		setPreferredSize(new Dimension(1400, 800));
		setMinimumSize(new Dimension(1400, 800));

		setLayout(new BorderLayout());

		chart = new TChart();
		add(chart, BorderLayout.CENTER);
		add(new Commander(chart.getChart()), BorderLayout.NORTH);

		series = new MyWorld();
		series.setUseColorRange(true);
		series.setUsePalette(true);
		series.getShadow().setVisible(false);
		series.setInGallery(true);
		series.setChart(chart.getChart());
		try {
			series.loadMapFromResource(series, "Italia");
		} catch (Exception e) {
			throw new RuntimeException(e);
		}

		add(createMapChooserControl(), BorderLayout.SOUTH);
	}

	private JComponent createMapChooserControl() {

		ChangeMapAction changeMapAction = new ChangeMapAction();

		JRadioButton radioItalia = new JRadioButton(changeMapAction);
		radioItalia.setText("Italia");
		JRadioButton radioItaliaRegioni = new JRadioButton(changeMapAction);
		radioItaliaRegioni.setText("ItaliaRegioni");
		JRadioButton radioItaliaProvince = new JRadioButton(changeMapAction);
		radioItaliaProvince.setText("ItaliaProvince");
		JRadioButton radioItaliaComuni = new JRadioButton(changeMapAction);
		radioItaliaComuni.setText("ItaliaComuni2");

		ButtonGroup buttonGroup = new ButtonGroup();
		buttonGroup.add(radioItalia);
		buttonGroup.add(radioItaliaRegioni);
		buttonGroup.add(radioItaliaProvince);
		buttonGroup.add(radioItaliaComuni);

		JPanel panel = new JPanel(new FlowLayout());
		panel.add(radioItalia);
		panel.add(radioItaliaRegioni);
		panel.add(radioItaliaProvince);
		panel.add(radioItaliaComuni);

		radioItalia.setSelected(true);

		return panel;
	}
}
